// Type definitions for @ckeditor/ckeditor5-font 27.1
// Project: https://ckeditor.com/docs/ckeditor5/latest/api/font.html
// Definitions by: Federico Panico <https://github.com/fedemp>
// Definitions: https://github.com/DefinitelyTyped/DefinitelyTyped
// Minimum TypeScript Version: 4.3
import Font from './src/font';
import FontBackgroundColor from './src/fontbackgroundcolor';
import FontColor from './src/fontcolor';
import FontFamily from './src/fontfamily';
import FontSize from './src/fontsize';
import FontBackgroundColorEditing from './src/fontbackgroundcolor/fontbackgroundcolorediting';
import FontBackgroundColorUI from './src/fontbackgroundcolor/fontbackgroundcolorui';
import FontColorEditing from './src/fontcolor/fontcolorediting';
import FontColorUI from './src/fontcolor/fontcolorui';
import FontFamilyEditing from './src/fontfamily/fontfamilyediting';
import FontFamilyUI from './src/fontfamily/fontfamilyui';
import FontSizeEditing from './src/fontsize/fontsizeediting';
import FontSizeUI from './src/fontsize/fontsizeui';

declare const _default: {
    Font: typeof Font;
    FontBackgroundColor: typeof FontBackgroundColor;
    FontColor: typeof FontColor;
    FontFamily: typeof FontFamily;
    FontSize: typeof FontSize;
    FontBackgroundColorEditing: typeof FontBackgroundColorEditing;
    FontBackgroundColorUI: typeof FontBackgroundColorUI;
    FontColorEditing: typeof FontColorEditing;
    FontColorUI: typeof FontColorUI;
    FontFamilyEditing: typeof FontFamilyEditing;
    FontFamilyUI: typeof FontFamilyUI;
    FontSizeEditing: typeof FontSizeEditing;
    FontSizeUI: typeof FontSizeUI;
};

export default _default;
